#include <amxmodx>
#include <core>
#include <sqlx>
#include <amxmisc>

#define PLUGIN  "Trofian Registration System"
#define AUTHOR  "Trofian"
#define VERSION "0.3 beta"
#pragma tabsize 0

new Handle:g_h_Sql;
new Handle:g_h_Sql_Connect;
new s_Name[32][32];
new read[32];
new name[32][32];

new s_Error[128];
new i_ErrNo;

//Cvars

//sql
new CVAR_sql_host;
new CVAR_sql_pswd;
new CVAR_sql_db;
new CVAR_sql_user;
//path
new CVAR_patch_login;
new CVAR_patch_reg;
//
new trsHost[64], trsUser[32], trsPass[32], trsDB[128];
new trsLogin[200], trsReg[200];
//

public plugin_init()
{
        register_plugin(PLUGIN, VERSION, AUTHOR);
}

public plugin_cfg()
{
		 set_task(3.0,"SQL_Init_Connect");
		 set_task(1.0,"CVAR_Init");
		 set_task(2.0,"CVAR_ExecuteConfig");
		 register_clcmd("say /reg","shommotd",ADMIN_ALL);
		 register_clcmd("say_team /reg","shommotd",ADMIN_ALL);
		 register_clcmd("say /auth","shommotda",ADMIN_ALL);
		 register_clcmd("say_team /auth","shommotda",ADMIN_ALL);
}

public CVAR_Init()
{
		CVAR_sql_host = register_cvar("trs_sql_dbhost"   ,"127.0.0.1");
		CVAR_sql_pswd = register_cvar("trs_sql_dbpass"   ,"");
		CVAR_sql_db   = register_cvar("trs_sql_dbname"   ,"amx");
		CVAR_sql_user = register_cvar("trs_sql_dbuser"   ,"root");
		
		CVAR_patch_login = register_cvar("trs_patch_to_login"   ,"http://localhost/trs/login.php");
		CVAR_patch_reg = register_cvar("trs_patch_to_reg"        ,"http://localhost/trs/reg.php");
}

public CVAR_ExecuteConfig()
{
			 	// Format our config file
	new szConfigFile[64];
	new szConfigFile2[64];
	get_configsdir(szConfigFile, 63 );
	get_configsdir(szConfigFile2, 63 );
	add( szConfigFile, 63, "/trs/sql.cfg" );
	add( szConfigFile2, 63, "/trs/cfg.cfg" );

	// Make sure the config file exists!
	if ( file_exists( szConfigFile ) )
	{
		server_cmd( "exec %s", szConfigFile );
	}
	else
	{
		server_print("[TRS] Error Config file '%s' missing!", szConfigFile);
	}
	
		// Make sure the config file exists!
	if ( file_exists( szConfigFile2 ) )
	{
		server_cmd( "exec %s", szConfigFile2 );
	}
	else
	{
		server_print("[TRS] Error Config file '%s' missing!", szConfigFile);
	}
}

public SQL_Init_Connect()
{
	get_pcvar_string( CVAR_sql_host	, trsHost		, 63	);
	get_pcvar_string( CVAR_sql_user	, trsUser		, 31	);
	get_pcvar_string( CVAR_sql_pswd	, trsPass		, 31	);
	get_pcvar_string( CVAR_sql_db	, trsDB			, 127	);

    g_h_Sql = SQL_MakeDbTuple(trsHost, trsUser, trsPass, trsDB);
    
    g_h_Sql_Connect = SQL_Connect(g_h_Sql, i_ErrNo, s_Error, charsmax(s_Error));
    
    if (g_h_Sql_Connect == Empty_Handle)
    {
        server_print("[TRS]Can't connect to MySQL, error: %s", s_Error);
        log_amx("[TRS]Can't connect to MySQL, error: %s", s_Error);
    }
    else{
		server_print("[TRS]Connect to MySQL success!");
		
		new Handle:h_Query1;
		h_Query1 = SQL_PrepareQuery(g_h_Sql_Connect, "SELECT * FROM `trs_users`;");
		if (!SQL_Execute(h_Query1)){
			new Handle:h_Query2;
			server_print("[TRS]The table is not found. The table is created.");
			h_Query2 = SQL_PrepareQuery(g_h_Sql_Connect, "CREATE TABLE `trs_users` (`name` varchar(33) character set latin1 NOT NULL,`flags` varchar(33) character set latin1 NOT NULL,`passwd` varchar(32) character set latin1 NOT NULL,`ingame` varchar(32) collate utf8_bin NOT NULL default '0') ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;");
			SQL_Execute(h_Query2);
			server_cmd("restart");
		}else{
		server_print("[TRS]Table exist.OK.");
		server_print("[TRS]Reset all logged users.");
		 new Handle:h_Query;
		h_Query = SQL_PrepareQuery(g_h_Sql_Connect, "UPDATE `trs_users` SET `ingame`='0';");
		register_event("ResetHUD", "SQL_Query", "be");
		SQL_Execute(h_Query);
	}
	}
	return PLUGIN_CONTINUE
} 

public SQL_Query(id)
{
		get_pcvar_string(CVAR_patch_login ,trsLogin, 199);
		
        new Handle:h_Query;
        
        h_Query = SQL_PrepareQuery(g_h_Sql_Connect, "SELECT `ingame` FROM `trs_users` WHERE `name`='%s' LIMIT 0,1;", s_Name[id]);
		
		if (!SQL_Execute(h_Query))
        {
            server_print("[TRS]Can't execute MySQL query, error");
            log_amx("[TRS]Can't execute MySQL query, error");
        }else{
			
			while (SQL_MoreResults(h_Query)){
			SQL_ReadResult(h_Query, 0, read[id], charsmax(read));

						if (read[id] == '1')
						client_cmd(id, "name %s", s_Name[id]);
					
						else if (read[id] == '0')
						{
							show_motd (id, trsLogin, "Login Form") ;
							get_user_name(id, name[id], charsmax(name));
							client_cmd(id, "name [NOT_logged]%s", name[id]);
							set_hudmessage ( 200, 0, 0, -1.0, 0.35, 0, 6.0, 30.0, 0.4, 0.2, 4);
							show_hudmessage (id, "Say /auth to autorizate");
						} 
						SQL_NextRow(h_Query)
					} 
        }    
		return PLUGIN_CONTINUE;
}

public client_disconnect(id)
{
new Handle:h_Query;
h_Query = SQL_PrepareQuery(g_h_Sql_Connect, "UPDATE trs_users SET ingame='0' WHERE name='%s';", s_Name[id]);
SQL_Execute(h_Query);
new null;
arrayset(s_Name[id], null, 31);
arrayset(name[id], null, 31);
return PLUGIN_CONTINUE;
}

public shommotd (id)
{
	if (equali(read[id], "1")){
			get_pcvar_string( CVAR_patch_reg, trsReg, 199);
show_motd (id, trsReg, "Reg Form");
	}
		if (equali(read[id], "0")){
			get_pcvar_string( CVAR_patch_reg, trsReg, 199);
show_motd (id, trsReg, "Reg Form");
	}
}

public shommotda (id)
{
	if (equali(read[id], "0")){
			get_pcvar_string( CVAR_patch_login, trsLogin, 199);
show_motd (id, trsLogin, "Login Form");
	}
}

public client_putinserver(id)
{
get_user_name(id, s_Name[id], charsmax(s_Name));
return PLUGIN_CONTINUE;
}

public client_infochanged(id)
{
if (equali(read[id], "1")){
client_cmd(id, "name %s", s_Name[id]);
set_hudmessage ( 200, 0, 0, -1.0, 0.35, 0, 6.0, 8.0, 0.4, 0.2, 4);
show_hudmessage (id, "You are registered user, you can't change name");
	}
	else if (equali(read[id], "0")){
client_cmd(id, "name [NOT_logged]%s", s_Name[id]);
set_hudmessage ( 200, 0, 0, -1.0, 0.35, 0, 6.0, 8.0, 0.4, 0.2, 4);
show_hudmessage (id, "You can't change name. ^n Pleas disconnect and change name.");
	}
}